﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Konfiguration                                                                       //
//  _________________________________                                                   //
//                                                                                      //
//  Copyright (c) 2019 Reimar Grasbon                                                   //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Typenschild  //////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define DEV_APPL_TYPE                     00124  // Anwendungstypennummer:             00100 ..  99999 [#]
#define DEV_APPL_VERS                        21  // Anwendungsversion (Major.Minor):      01 ..     99 [#]
#define DEV_BOARD_TYPE                    00028  // Boardtypennummer:                  00001 ..  99999 [#]
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define GENADR_A(T) (100 + (10 ## T))            // GENADR_XX erzeugt aus den beiden letzten Stellen der
#define GENADR_B(X) GENADR_A(X%100)              // Boardtypennummer in <DEV_BOARD_TYPE> die werksvoreinge-
#define GENADR_XX   GENADR_B(DEV_BOARD_TYPE)     // stellte Geräteadresse gemäß Cy4NET-Konvention: 100 + xx

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Konfiguration  ////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define CFG_PGMLDR_SIZE                       2  // Größe des Programmladers                         1/2/4       [KiB]
#define CFG_DEFAULT_CY4_ADDRESS_NET         255  // Voreingestellte-Cy4-Netzadresse:                 1 ..   255  [#]
#define CFG_DEFAULT_CY4_ADDRESS_DEV   GENADR_XX  // Voreingestellte-Cy4-Geräteadresse:               1 ..   254  [#]
#define CFG_CY4_POSTING_QUEUE_CAPACITY        5  // Kapazität der CY4-Sendeschlange:                 1 ..   100  [Sendungen]
#define CFG_EEP_CY4_ADDRESS_PARTITION         2  // EEProm-Start der Cy4-Adress-Partition:           0 ..  1023  [#]
#define CFG_EEP_STORING_PARTITION            10  // EEProm-Start der Datenaufbewahrungs-Partition:   0 ..  1023  [#]
#define CFG_BUS_ACT_INDICATOR_DURATION       25  // Haltedauer des Bus-Aktivitätsindikators:         0 ..   250  [ms]
#define CFG_BUS_TX_QUEUE_CAPACITY            75  // Kapazität der Bus-Sendeschlange:                 1 ..   250  [Bytes]
#define CFG_BUS_RX_QUEUE_CAPACITY           150  // Kapazität der Bus-Empfangsschlange:              1 ..   250  [Bytes]
#define CFG_BUS_INTERBYTE_TIMEOUT             3  // Zeitüberschreitung bei Bus-Byteempfang:          1 ..    30  [ms]
#define CFG_TEMPERATURE_INVALID            -128  // Wert für "ungültige Temperatur":              -128 ..   127  [#]
#define CFG_TEMPERATURE_UPDATE               20  // Temperatur - Aktualisierungsintervall:           1 ..  3600  [s]
#define CFG_TEMPERATURE_AVERAGINGS           10  // Temperatur - Anzahl Mittelungen:                 3 ..    50  [Mittelungen]
#define CFG_TEMPERATURE_LOG_INTERVAL          3  // Zeitintervall der Temperaturaufzeichnung:        3 ..    60  [min]
#define CFG_TEMPERATURE_LOG_CAPACITY        480  // Kapazität der Temperaturaufzeichnung:            1 ..   800  [Einträge]
#define CFG_TEMPERATURE_TREND_PERIOD        120  // Beobachtungszeitraum für den Temperaturtrend:    3 ..   720  [min]
#define CFG_AIR_PRESSURE_UPDATE               8  // Luftdruck - Aktualisierungsintervall:            4 ..   300  [s]
#define CFG_AIR_PRESSURE_TREND_PERIOD       120  // Beobachtungszeitraum für den Luftdrucktrend:     3 ..   720  [min]
#define CFG_MIN_BROADCAST_PAUSE             300  // Minimale Pause nach Rundnachricht:              25 .. 15000  [s]
#define CFG_INITIAL_TIME_QUERY_DELAY         10  // Erste Zeitserveranfrage nach Systemstart nach:   1 ..   50 [s]
#define CFG_TIME_QUERY_INTERVAL              75  // Anfrageintervall an den Zeitserver:              5 ..  240 [min]

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

